<template>
  <q-card>
    <q-card-section>
      <div class="text-h6">JetRacer Stats</div>
    </q-card-section>
    <q-card-section>
      <div v-if="racerIsConnected">
        <q-badge rounded color="green" /> Device Connected
      </div>
      <div v-else>
        <div><q-badge rounded color="red" /> Device Not Connected</div>
        <div>{{errorMsg}}</div>
      </div>
      <div v-if="racerIsConnected">
        <div>
          <strong>Device Name:</strong> {{nerdStats.hostname}}
        </div>
        <div>
          <strong>IP:</strong> {{nerdStats.ip_addr}}
        </div>
      </div>
    </q-card-section>
    <div v-if="racerIsConnected">
      <q-card-section>
        <div class="text-h6">System Usage</div>
        <div>
          <strong>Ram:</strong> {{convertToGb(nerdStats.ram.used)}} GB / {{convertToGb(nerdStats.ram.total)}} GB ({{nerdStats.ram.percent_used.toFixed(2)}}%)
        </div>
        <div>
          <strong>CPU:</strong> {{calculateCpuPercent(nerdStats.cpu_usage)}}% used
        </div>
        <div>
          <strong>Storage:</strong> {{convertToGb(nerdStats.storage.used)}} GB / {{convertToGb(nerdStats.storage.total)}} GB used
        </div>
      </q-card-section>
      <q-card-section>
        <div class="text-h6">Application Status</div>
<!--        <div v-if="selected_device != null">-->
<!--          <q-badge rounded color="green" /> Running-->
<!--        </div>-->
<!--        <div v-else>-->
<!--          <q-badge rounded color="red" /> Stopped-->
<!--        </div>-->
        <div>
          <q-badge rounded color="grey" /> Unknown
        </div>
        <div>
          <strong>Running for:</strong> Unknown
<!--          {{dateDifference(new Date(startedAt))}}-->
        </div>
        <div>
          <strong>Model:</strong> {{nerdStats.model_name}}
        </div>
      </q-card-section>
    </div>
<!--    <q-card-section v-if="isAdmin">-->
<!--      <q-select filled v-model="selected_device" :options="allPis" label="Select Racer" :option-label="opt => Object(opt) === opt && 'group' in opt ? opt.group  : ''" />-->
<!--    </q-card-section>-->
    <!-- <q-card-section> -->
    <!--   <q-btn color="primary" label="Stop the app" /> -->
    <!-- </q-card-section> -->
  </q-card>
</template>
<script>
import { ref } from 'vue';
import { usePiStore } from 'stores/backend';

export default {
  setup () {
    const piStore = usePiStore();
    const timer = setInterval(() => {
      getStats();
    }, 7000)

    const allPis = ref([])
    const data = ref([])
    // const model = ref()
    // const selected_device = ref();
    const errorMsg = ref('');
    const isAdmin = ref(true);
    const racerIsConnected = ref(false);
    const nerdStats = ref([]);

    // loadData();
    getStats();

    const dateDifference = (date) => {
      const diffMs = (date - Date.now());
      const diffMins = Math.round(((diffMs % 86400000) % 3600000) / 60000);

      return diffMins;
    }

    const convertToGb = (num) => {
      return (num / 1024 ** 3).toFixed(2)
    }

    const calculateCpuPercent = (percentageList) => {
      let sum = 0;

      percentageList.forEach(addUp);

      return (sum / percentageList.length).toFixed(2);

      function addUp(percentage) {
        sum = sum + percentage;
      }
    }

    // const selectDevice = (id) => {
    //   selected_device = allPis.value.find(device => device.id = id);
    // }

    async function loadData(){
      allPis.value = (await piStore.getAllPis()).data;
    }

    async function getStats() {
      try {
        nerdStats.value = (await piStore.getStats()).data;
        racerIsConnected.value = true;
      } catch (e) {
        // console.log(e);
        // if (e.response.status == 404) {
        //   clearInterval(timer);
        // }

        switch (e.response.status) {
          case 404:
            clearInterval(timer);
            errorMsg.value = e.response.data.toString();
            break;
          case 408:
            errorMsg.value = e.response.data.toString();
            break;
          default:
            clearInterval(timer);
            errorMsg.value = "An unknown error occurred. Reload the page to try again."
            break;
        }
        racerIsConnected.value = false;
      }
    }

    // TODO: Set selected_device automatically based on login

    return {
      allPis,
      data,
      // selected_device,
      errorMsg,
      isAdmin,
      racerIsConnected,
      nerdStats,
      dateDifference,
      convertToGb,
      calculateCpuPercent,
      // selectDevice,
      timer
    }
  },

  beforeUnmount() {
    clearInterval(this.timer);
  }

}
</script>
